'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; desc = parent = getter = undefined; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Styling = require('../Styling');

var _Styling2 = _interopRequireDefault(_Styling);

var styles = {
  checkbox: {
    WebkitUserSelect: 'none',
    WebkitAppearance: 'none',
    borderWidth: '2px',
    borderStyle: 'solid',
    borderColor: 'rgba(171,173,179,1)',
    padding: '8px',
    color: '#fff',
    verticalAlign: 'bottom',
    marginRight: '5px',

    ':focus': {
      outline: 'none',
      borderColor: '#007CD1'
    },

    ':active': {
      borderColor: '#007CD1'
    },

    ':checked': {
      background: '#007CD1',
      borderColor: '#007CD1'
    },

    ':hover': {
      borderColor: 'rgba(100, 100, 100, 1)'
    }
  },

  label: {
    fontFamily: '"Segoe UI", Frutiger, "Frutiger Linotype", "Dejavu Sans", "Helvetica Neue", Arial, sans-serif',
    fontSize: '14px',
    lineHeight: '27px',
    position: 'relative'
  },

  checked: {
    position: 'absolute',
    top: '5px',
    left: '6px',
    color: '#fff',
    height: '16px'
  }
};

var CheckboxWindows = (function (_Component) {
  _inherits(CheckboxWindows, _Component);

  _createClass(CheckboxWindows, null, [{
    key: 'propTypes',
    value: {
      style: _react.PropTypes.object,
      row: _react.PropTypes.any,
      form: _react.PropTypes.any,
      label: _react.PropTypes.string,
      visible: _react.PropTypes.bool,
      display: _react.PropTypes.bool
    },
    enumerable: true
  }]);

  function CheckboxWindows(props) {
    _classCallCheck(this, _CheckboxWindows);

    _get(Object.getPrototypeOf(_CheckboxWindows.prototype), 'constructor', this).call(this);
    this.onChange = this.onChange.bind(this);
    this.state = {
      visible: props.visible !== false,
      display: props.display !== false,
      checked: props.defaultChecked === true
    };
  }

  _createClass(CheckboxWindows, [{
    key: 'onChange',
    value: function onChange(event) {
      this.setState({ checked: event.target.checked });
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props;
      var style = _props.style;
      var row = _props.row;
      var form = _props.form;
      var display = _props.display;
      var visible = _props.visible;
      var label = _props.label;

      var props = _objectWithoutProperties(_props, ['style', 'row', 'form', 'display', 'visible', 'label']);

      var componentStyle = this.styles;
      var checkedStyle = { display: 'none' };

      if (this.state.checked) {
        checkedStyle = styles['checked'];
      }

      componentStyle = (0, _Styling.mergeStyles)(componentStyle, {
        visibility: this.state.visible ? 'visible' : 'hidden',
        display: this.state.display ? 'inline-block' : 'none'
      });

      return _react2['default'].createElement(
        'label',
        { style: styles.label },
        _react2['default'].createElement('input', _extends({
          ref: 'element',
          type: 'checkbox'
        }, props, {
          'data-style': (0, _Styling.applyStyle)(componentStyle),
          checked: this.state.checked,
          onChange: this.onChange
        })),
        _react2['default'].createElement(
          'svg',
          { x: '0px', y: '0px', viewBox: '0 0 6.4 6.4', style: checkedStyle },
          _react2['default'].createElement('polygon', { fill: '#fff', points: '0,3.3 2.2,5.5 6.4,1.23 6.1,0.9 2.2,4.8 0.3,2.9 ' })
        ),
        label
      );
    }
  }, {
    key: 'styles',
    get: function get() {
      return (0, _Styling.mergeStyles)(styles.checkbox, this.props.style);
    }
  }]);

  var _CheckboxWindows = CheckboxWindows;
  CheckboxWindows = (0, _Styling2['default'])(CheckboxWindows) || CheckboxWindows;
  return CheckboxWindows;
})(_react.Component);

exports['default'] = CheckboxWindows;
module.exports = exports['default'];