'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; desc = parent = getter = undefined; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Styling = require('../../Styling');

var _Desktop = require('../../Desktop');

var _Desktop2 = _interopRequireDefault(_Desktop);

var _Label = require('../../Label');

var _Label2 = _interopRequireDefault(_Label);

var _LabelLabelOsx = require('../../Label/Label.osx');

var _LabelLabelOsx2 = _interopRequireDefault(_LabelLabelOsx);

var _TextBlockTextBlockWindows = require('../../TextBlock/TextBlock.windows');

var _TextBlockTextBlockWindows2 = _interopRequireDefault(_TextBlockTextBlockWindows);

var _TextInput = require('../../TextInput');

var _TextInput2 = _interopRequireDefault(_TextInput);

var _TextInputTextFieldOsx = require('../../TextInput/TextField.osx');

var _TextInputTextFieldOsx2 = _interopRequireDefault(_TextInputTextFieldOsx);

var _TextInputTextBoxWindows = require('../../TextInput/TextBox.windows');

var _TextInputTextBoxWindows2 = _interopRequireDefault(_TextInputTextBoxWindows);

var _Button = require('../../Button');

var _Button2 = _interopRequireDefault(_Button);

var _ButtonPushButtonOsx = require('../../Button/PushButton.osx');

var _ButtonPushButtonOsx2 = _interopRequireDefault(_ButtonPushButtonOsx);

var _ButtonButtonWindows = require('../../Button/Button.windows');

var _ButtonButtonWindows2 = _interopRequireDefault(_ButtonButtonWindows);

var styles = {
  row: {
    WebkitUserSelect: 'none',
    cursor: 'default',
    display: 'flex',
    justifyContent: 'center',
    alignItems: 'center'
  },

  rowOsx: {
    marginBottom: '20px'
  },

  rowWin: {
    marginBottom: '12px'
  },

  buttonRowOsx: {
    marginTop: '4px'
  },

  buttonRowWin: {
    marginTop: '30px'
  }
};

var Row = (function (_Component) {
  _inherits(Row, _Component);

  _createClass(Row, null, [{
    key: 'propTypes',
    value: {
      children: _react.PropTypes.oneOfType([_react2['default'].PropTypes.string, _react2['default'].PropTypes.element, _react2['default'].PropTypes.array]),
      style: _react.PropTypes.object,
      form: _react.PropTypes.any,
      visible: _react.PropTypes.bool,
      display: _react.PropTypes.bool
    },
    enumerable: true
  }]);

  function Row(props) {
    _classCallCheck(this, Row);

    _get(Object.getPrototypeOf(Row.prototype), 'constructor', this).call(this);
    this.state = { visible: props.visible !== false, display: props.display !== false };
  }

  _createClass(Row, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      if (this.props.form) {
        this.props.form.registerRow(this);
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props;
      var children = _props.children;
      var style = _props.style;
      var form = _props.form;
      var display = _props.display;
      var visible = _props.visible;

      var props = _objectWithoutProperties(_props, ['children', 'style', 'form', 'display', 'visible']);

      var isButtonsRow = null;
      var componentStyle = (0, _Styling.mergeStyles)(style, styles.row, _Desktop2['default'].os === 'win' ? styles.rowWin : styles.rowOsx);

      children = _react.Children.map(children, (function (element) {
        if (element.type === _Label2['default'] || element.type === _LabelLabelOsx2['default'] || element.type === _TextBlockTextBlockWindows2['default']) {
          isButtonsRow = false;
        } else if (element.type === _TextInput2['default'] || element.type === _TextInputTextFieldOsx2['default'] || element.type === _TextInputTextBoxWindows2['default']) {
          isButtonsRow = false;
        } else if ((element.type === _Button2['default'] || element.type === _ButtonPushButtonOsx2['default'] || element.type === _ButtonButtonWindows2['default']) && isButtonsRow === null) {
          isButtonsRow = true;
        }
        return (0, _react.cloneElement)(element, { form: form, row: this });
      }).bind(this));

      if (isButtonsRow) {
        componentStyle = (0, _Styling.mergeStyles)(componentStyle, _Desktop2['default'].os === 'win' ? styles.buttonRowWin : styles.buttonRowOsx);
      }

      componentStyle = (0, _Styling.mergeStyles)(componentStyle, styles.row, {
        visibility: this.state.visible ? 'visible' : 'hidden',
        display: this.state.display ? 'flex' : 'none'
      });

      return _react2['default'].createElement(
        'div',
        _extends({ style: componentStyle }, props),
        children
      );
    }
  }]);

  return Row;
})(_react.Component);

exports['default'] = Row;
module.exports = exports['default'];