'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; desc = parent = getter = undefined; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Styling = require('../Styling');

var styles = {
  textBlock: {
    WebkitUserSelect: 'none',
    cursor: 'default',
    lineHeight: '25.96px',
    fontFamily: '"Segoe UI", Frutiger, "Frutiger Linotype", "Dejavu Sans", "Helvetica Neue", Arial, sans-serif',
    fontSize: '14px',
    whiteSpace: 'nowrap'
  },

  rowLabel: {
    textAlign: 'right',
    marginRight: '12px'
  }
};

var TextBlockWindows = (function (_Component) {
  _inherits(TextBlockWindows, _Component);

  _createClass(TextBlockWindows, null, [{
    key: 'propTypes',
    value: {
      children: _react.PropTypes.oneOfType([_react2['default'].PropTypes.string, _react2['default'].PropTypes.element, _react2['default'].PropTypes.array]),
      style: _react.PropTypes.object,
      color: _react.PropTypes.string,
      row: _react.PropTypes.any,
      form: _react.PropTypes.any,
      align: _react.PropTypes.string,
      visible: _react.PropTypes.bool,
      display: _react.PropTypes.bool
    },
    enumerable: true
  }]);

  function TextBlockWindows(props) {
    _classCallCheck(this, TextBlockWindows);

    _get(Object.getPrototypeOf(TextBlockWindows.prototype), 'constructor', this).call(this);
    this.state = { visible: props.visible !== false, display: props.display !== false };
  }

  _createClass(TextBlockWindows, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      if (this.props.row && this.props.form) {
        this.props.form.registerLabel(this);
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props;
      var children = _props.children;
      var style = _props.style;
      var color = _props.color;
      var row = _props.row;
      var form = _props.form;
      var align = _props.align;
      var display = _props.display;
      var visible = _props.visible;

      var props = _objectWithoutProperties(_props, ['children', 'style', 'color', 'row', 'form', 'align', 'display', 'visible']);

      var componentStyle = this.styles;

      if (color) {
        switch (color) {
          case 'red':
            color = '#c50500';
            break;
        }
        componentStyle = (0, _Styling.mergeStyles)(componentStyle, { color: color });
      }

      if (row) {
        componentStyle = (0, _Styling.mergeStyles)(componentStyle, styles.rowLabel);
      }

      if (align) {
        componentStyle = (0, _Styling.mergeStyles)(componentStyle, { textAlign: align });
      }

      componentStyle = (0, _Styling.mergeStyles)(componentStyle, {
        visibility: this.state.visible ? 'visible' : 'hidden',
        display: this.state.display ? 'block' : 'none'
      });

      return _react2['default'].createElement(
        'div',
        _extends({
          ref: 'label',
          style: componentStyle
        }, props),
        children
      );
    }
  }, {
    key: 'styles',
    get: function get() {
      return (0, _Styling.mergeStyles)(styles.textBlock, this.props.style);
    }
  }]);

  return TextBlockWindows;
})(_react.Component);

exports['default'] = TextBlockWindows;
module.exports = exports['default'];