'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; desc = parent = getter = undefined; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Styling = require('../../Styling');

var _Styling2 = _interopRequireDefault(_Styling);

var _WindowState = require('../../WindowState');

var _WindowState2 = _interopRequireDefault(_WindowState);

var styles = {
  button: {
    WebkitUserSelect: 'none',
    WebkitAppRegion: 'no-drag',
    cursor: 'default',
    width: '10px',
    height: '10px',
    borderWidth: '1px',
    borderStyle: 'solid',
    borderRadius: '50%',
    marginBottom: '.5px',
    marginLeft: '4px',
    marginRight: '4px',
    lineHeight: 0,
    backgroundColor: '#ff5f57',
    borderColor: '#e2463f',

    ':active': {
      backgroundColor: '#bf4943',
      borderColor: '#ad3934'
    }
  },

  unfocused: {
    backgroundColor: '#dddddd',
    borderColor: '#d0d0d0'
  },

  icon: {
    width: '6px',
    height: '6px',
    marginTop: '2px',
    marginLeft: '2px'
  }
};

var Close = (function (_Component) {
  _inherits(Close, _Component);

  _createClass(Close, null, [{
    key: 'propTypes',
    value: {
      style: _react.PropTypes.object
    },
    enumerable: true
  }]);

  function Close() {
    _classCallCheck(this, _Close);

    _get(Object.getPrototypeOf(_Close.prototype), 'constructor', this).call(this);
    this.state = { iconVisible: false, windowFocused: true };
  }

  _createClass(Close, [{
    key: 'render',
    value: function render() {
      var _props = this.props;
      var style = _props.style;

      var props = _objectWithoutProperties(_props, ['style']);

      var displayIcon = this.state.iconVisible ? { opacity: 1 } : { opacity: 0 };
      var iconStyle = (0, _Styling.mergeStyles)(styles.icon, displayIcon);

      var componentStyle = style;
      if (!this.state.windowFocused && !this.state.iconVisible) {
        componentStyle = (0, _Styling.mergeStyles)(componentStyle, styles.unfocused);
      }

      return _react2['default'].createElement(
        'a',
        _extends({
          'data-style': (0, _Styling.applyStyle)(styles.button),
          style: componentStyle
        }, props),
        _react2['default'].createElement(
          'svg',
          { x: '0px', y: '0px', viewBox: '0 0 6.4 6.4', style: iconStyle },
          _react2['default'].createElement('polygon', { fill: '#4d0000', points: '6.4,0.8 5.6,0 3.2,2.4 0.8,0 0,0.8 2.4,3.2 0,5.6 0.8,6.4 3.2,4 5.6,6.4 6.4,5.6 4,3.2 ' })
        )
      );
    }
  }]);

  var _Close = Close;
  Close = (0, _Styling2['default'])(Close) || Close;
  Close = (0, _WindowState2['default'])(Close) || Close;
  return Close;
})(_react.Component);

exports['default'] = Close;
module.exports = exports['default'];