'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = (function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ('value' in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; })();

var _get = function get(_x, _x2, _x3) { var _again = true; _function: while (_again) { var object = _x, property = _x2, receiver = _x3; desc = parent = getter = undefined; _again = false; if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { _x = parent; _x2 = property; _x3 = receiver; _again = true; continue _function; } } else if ('value' in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } } };

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { 'default': obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError('Cannot call a class as a function'); } }

function _inherits(subClass, superClass) { if (typeof superClass !== 'function' && superClass !== null) { throw new TypeError('Super expression must either be null or a function, not ' + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Styling = require('../Styling');

var _WindowState = require('../WindowState');

var _WindowState2 = _interopRequireDefault(_WindowState);

var _TitleBar = require('../TitleBar');

var _TitleBar2 = _interopRequireDefault(_TitleBar);

var _TitleBarTitleBarWindows = require('../TitleBar/TitleBar.windows');

var _TitleBarTitleBarWindows2 = _interopRequireDefault(_TitleBarTitleBarWindows);

var styles = {
  window: {
    WebkitUserSelect: 'none',
    cursor: 'default',
    backgroundColor: '#ffffff',
    display: 'flex',
    flexDirection: 'column'
  },

  chrome: {
    borderWidth: '1px',
    borderStyle: 'solid',
    borderColor: '#1883d7',
    boxShadow: '0 2px 11px 3px rgba(0, 0, 0, .2)'
  },

  unfocused: {
    borderColor: '#aaaaaa'
  },

  content: {
    margin: '24px 20px 20px 20px'
  }
};

var WindowWindows = (function (_Component) {
  _inherits(WindowWindows, _Component);

  _createClass(WindowWindows, null, [{
    key: 'propTypes',
    value: {
      children: _react.PropTypes.oneOfType([_react2['default'].PropTypes.string, _react2['default'].PropTypes.element, _react2['default'].PropTypes.array]),
      style: _react.PropTypes.object,
      chrome: _react.PropTypes.bool,
      border: _react.PropTypes.string,
      visible: _react.PropTypes.bool,
      display: _react.PropTypes.bool
    },
    enumerable: true
  }]);

  function WindowWindows(props) {
    _classCallCheck(this, _WindowWindows);

    _get(Object.getPrototypeOf(_WindowWindows.prototype), 'constructor', this).call(this);
    this.state = {
      windowFocused: true,
      visible: props.visible !== false,
      display: props.display !== false
    };
  }

  _createClass(WindowWindows, [{
    key: 'render',
    value: function render() {
      var _props = this.props;
      var style = _props.style;
      var border = _props.border;
      var chrome = _props.chrome;
      var children = _props.children;
      var visible = _props.visible;
      var display = _props.display;

      var props = _objectWithoutProperties(_props, ['style', 'border', 'chrome', 'children', 'visible', 'display']);

      var compoentStyle = this.styles;
      if (chrome) {
        compoentStyle = (0, _Styling.mergeStyles)(compoentStyle, styles.chrome);

        if (!this.state.windowFocused) {
          compoentStyle = (0, _Styling.mergeStyles)(compoentStyle, styles.unfocused);
        }
      }

      var titleBar = _react.Children.map(children, (function (element) {
        if (element.type === _TitleBar2['default'] || element.type === _TitleBarTitleBarWindows2['default']) {
          return element;
        }
      }).bind(this));

      children = _react.Children.map(children, (function (element) {
        if (element.type !== _TitleBar2['default'] && element.type !== _TitleBarTitleBarWindows2['default']) {
          return element;
        }
      }).bind(this));

      compoentStyle = (0, _Styling.mergeStyles)(compoentStyle, {
        visibility: this.state.visible ? 'visible' : 'hidden',
        display: this.state.display ? 'flex' : 'none'
      });

      if (border) {
        styles = (0, _Styling.mergeStyles)(styles, { borderColor: border });
      }

      return _react2['default'].createElement(
        'div',
        _extends({
          style: compoentStyle
        }, props),
        titleBar,
        _react2['default'].createElement(
          'div',
          { style: styles.content },
          children
        )
      );
    }
  }, {
    key: 'styles',
    get: function get() {
      return (0, _Styling.mergeStyles)(styles.window, this.props.style);
    }
  }]);

  var _WindowWindows = WindowWindows;
  WindowWindows = (0, _WindowState2['default'])(WindowWindows) || WindowWindows;
  return WindowWindows;
})(_react.Component);

exports['default'] = WindowWindows;
module.exports = exports['default'];